## telegram-desktop 3.4.3+ds

=== Telegram/CMakeLists.txt ===
# This file is part of Telegram Desktop,
# the official desktop application for the Telegram messaging service.
#
# For license and copyright information please follow this link:
# https://github.com/telegramdesktop/tdesktop/blob/master/LEGAL

add_executable(Telegram WIN32 MACOSX_BUNDLE)
init_non_host_target(Telegram)

add_subdirectory(lib_rpl)
add_subdirectory(lib_crl)
add_subdirectory(lib_base)
add_subdirectory(lib_ui)
add_subdirectory(lib_tl)
if (NOT DESKTOP_APP_DISABLE_SPELLCHECK)
    add_subdirectory(lib_spellcheck)
endif()
add_subdirectory(lib_storage)
add_subdirectory(lib_lottie)
add_subdirectory(lib_qr)
if (LINUX AND NOT DESKTOP_APP_DISABLE_WAYLAND_INTEGRATION)
    add_subdirectory(lib_waylandshells)
endif()
add_subdirectory(lib_webrtc)
add_subdirectory(lib_webview)
add_subdirectory(codegen)

get_filename_component(src_loc SourceFiles REALPATH)
get_filename_component(res_loc Resources REALPATH)

include(cmake/telegram_options.cmake)
include(cmake/lib_ffmpeg.cmake)
include(cmake/lib_stripe.cmake)
include(cmake/lib_tgvoip.cmake)
include(cmake/lib_tgcalls.cmake)
include(cmake/td_export.cmake)
include(cmake/td_mtproto.cmake)
include(cmake/td_lang.cmake)
include(cmake/td_scheme.cmake)
include(cmake/td_ui.cmake)
include(cmake/generate_appdata_changelog.cmake)

if (WIN32)
    include(cmake/generate_midl.cmake)
    generate_midl(Telegram ${src_loc}
        platform/win/windows_quiethours.idl
        platform/win/windows_toastactivator.idl
    )

    nuget_add_winrt(Telegram)
endif()

set_target_properties(Telegram PROPERTIES AUTOMOC ON)
target_prepare_qrc(Telegram)

target_link_libraries(Telegram
PRIVATE
    tdesktop::lib_tgcalls_legacy
    tdesktop::lib_tgcalls
    tdesktop::lib_tgvoip

    # Order in this list defines the order of include paths in command line.
    # We need to place desktop-app::external_minizip this early to have its
    # include paths (usually ${PREFIX}/include/minizip) before any depend that
    # would add ${PREFIX}/include. This path may have a different <zip.h>,
    # for example installed by libzip (https://libzip.org).
    desktop-app::external_minizip

    tdesktop::td_export
    tdesktop::td_mtproto
    tdesktop::td_lang
    tdesktop::td_scheme
    tdesktop::td_ui
    desktop-app::lib_webrtc
    desktop-app::lib_base
    desktop-app::lib_crl
    desktop-app::lib_ui
    desktop-app::lib_tl
    desktop-app::lib_storage
    desktop-app::lib_lottie
    desktop-app::lib_qr
    desktop-app::lib_webview
    desktop-app::lib_ffmpeg
    desktop-app::lib_stripe
    desktop-app::external_lz4
    desktop-app::external_rlottie
    desktop-app::external_zlib
    desktop-app::external_qt_static_plugins
    desktop-app::external_qt
    desktop-app::external_qr_code_generator
    desktop-app::external_crash_reports
    desktop-app::external_auto_updates
    desktop-app::external_openssl
    desktop-app::external_openal
    desktop-app::external_xxhash
)

target_precompile_headers(Telegram PRIVATE ${src_loc}/stdafx.h)
nice_target_sources(Telegram ${src_loc}
PRIVATE
    ${style_files}

    api/api_attached_stickers.cpp
    api/api_attached_stickers.h
    api/api_authorizations.cpp
    api/api_authorizations.h
    api/api_blocked_peers.cpp
    api/api_blocked_peers.h
    api/api_bot.cpp
    api/api_bot.h
    api/api_chat_filters.cpp
    api/api_chat_filters.h
    api/api_chat_invite.cpp
    api/api_chat_invite.h
    api/api_chat_participants.cpp
    api/api_chat_participants.h
    api/api_cloud_password.cpp
    api/api_cloud_password.h
    api/api_common.h
    api/api_confirm_phone.cpp
    api/api_confirm_phone.h
    api/api_editing.cpp
    api/api_editing.h
    api/api_global_privacy.cpp
    api/api_global_privacy.h
    api/api_hash.cpp
    api/api_hash.h
    api/api_invite_links.cpp
    api/api_invite_links.h
    api/api_media.cpp
    api/api_media.h
    api/api_peer_photo.cpp
    api/api_peer_photo.h
    api/api_polls.cpp
    api/api_polls.h
    api/api_self_destruct.cpp
    api/api_self_destruct.h
    api/api_send_progress.cpp
    api/api_send_progress.h
    api/api_sending.cpp
    api/api_sending.h
    api/api_sensitive_content.cpp
    api/api_sensitive_content.h
    api/api_single_message_search.cpp
    api/api_single_message_search.h
    api/api_text_entities.cpp
    api/api_text_entities.h
    api/api_toggling_media.cpp
    api/api_toggling_media.h
    api/api_updates.cpp
    api/api_updates.h
    api/api_user_privacy.cpp
    api/api_user_privacy.h
    api/api_views.cpp
    api/api_views.h
    api/api_who_reacted.cpp
    api/api_who_reacted.h
    boxes/filters/edit_filter_box.cpp
    boxes/filters/edit_filter_box.h
    boxes/filters/edit_filter_chats_list.cpp
    boxes/filters/edit_filter_chats_list.h
    boxes/peers/add_participants_box.cpp
    boxes/peers/add_participants_box.h
    boxes/peers/edit_contact_box.cpp
    boxes/peers/edit_contact_box.h
    boxes/peers/edit_linked_chat_box.cpp
    boxes/peers/edit_linked_chat_box.h
    boxes/peers/edit_participant_box.cpp
    boxes/peers/edit_participant_box.h
    boxes/peers/edit_participants_box.cpp
    boxes/peers/edit_participants_box.h
    boxes/peers/edit_peer_common.h
    boxes/peers/edit_peer_info_box.cpp
    boxes/peers/edit_peer_info_box.h
    boxes/peers/edit_peer_invite_link.cpp
    boxes/peers/edit_peer_invite_link.h
    boxes/peers/edit_peer_invite_links.cpp
    boxes/peers/edit_peer_invite_links.h
    boxes/peers/edit_peer_history_visibility_box.cpp
    boxes/peers/edit_peer_history_visibility_box.h
    boxes/peers/edit_peer_permissions_box.cpp
    boxes/peers/edit_peer_permissions_box.h
    boxes/peers/edit_peer_reactions.cpp
    boxes/peers/edit_peer_reactions.h
    boxes/peers/edit_peer_requests_box.cpp
    boxes/peers/edit_peer_requests_box.h
    boxes/peers/edit_peer_type_box.cpp
    boxes/peers/edit_peer_type_box.h
    boxes/peers/peer_short_info_box.cpp
    boxes/peers/peer_short_info_box.h
    boxes/peers/prepare_short_info_box.cpp
    boxes/peers/prepare_short_info_box.h
    boxes/about_box.cpp
    boxes/about_box.h
    boxes/about_sponsored_box.cpp
    boxes/about_sponsored_box.h
    boxes/abstract_box.cpp
    boxes/abstract_box.h
    boxes/add_contact_box.cpp
    boxes/add_contact_box.h
    boxes/auto_lock_box.cpp
    boxes/auto_lock_box.h
    boxes/auto_download_box.cpp
    boxes/auto_download_box.h
    boxes/background_box.cpp
    boxes/background_box.h
    boxes/background_preview_box.cpp
    boxes/background_preview_box.h
    boxes/change_phone_box.cpp
    boxes/change_phone_box.h
    boxes/connection_box.cpp
    boxes/connection_box.h
    boxes/create_poll_box.cpp
    boxes/create_poll_box.h
    boxes/delete_messages_box.cpp
    boxes/delete_messages_box.h
    boxes/dictionaries_manager.cpp
    boxes/dictionaries_manager.h
    boxes/download_path_box.cpp
    boxes/download_path_box.h
    boxes/edit_caption_box.cpp
    boxes/edit_caption_box.h
    boxes/edit_color_box.cpp
    boxes/edit_color_box.h
    boxes/edit_privacy_box.cpp
    boxes/edit_privacy_box.h
    boxes/language_box.cpp
    boxes/language_box.h
    boxes/local_storage_box.cpp
    boxes/local_storage_box.h
    boxes/max_invite_box.cpp
    boxes/max_invite_box.h
    boxes/mute_settings_box.cpp
    boxes/mute_settings_box.h
    boxes/peer_list_box.cpp
    boxes/peer_list_box.h
    boxes/peer_list_controllers.cpp
    boxes/peer_list_controllers.h
    boxes/peer_lists_box.cpp
    boxes/peer_lists_box.h
    boxes/passcode_box.cpp
    boxes/passcode_box.h
    boxes/phone_banned_box.cpp
    boxes/phone_banned_box.h
    boxes/pin_messages_box.cpp
    boxes/pin_messages_box.h
    boxes/self_destruction_box.cpp
    boxes/self_destruction_box.h
    boxes/send_files_box.cpp
    boxes/send_files_box.h
    boxes/sessions_box.cpp
    boxes/sessions_box.h
    boxes/share_box.cpp
    boxes/share_box.h
    boxes/sticker_set_box.cpp
    boxes/sticker_set_box.h
    boxes/stickers_box.cpp
    boxes/stickers_box.h
    boxes/url_auth_box.cpp
    boxes/url_auth_box.h
    boxes/username_box.cpp
    boxes/username_box.h
    calls/group/calls_choose_join_as.cpp
    calls/group/calls_choose_join_as.h
    calls/group/calls_cover_item.cpp
    calls/group/calls_cover_item.h
    calls/group/calls_group_call.cpp
    calls/group/calls_group_call.h
    calls/group/calls_group_common.cpp
    calls/group/calls_group_common.h
    calls/group/calls_group_invite_controller.cpp
    calls/group/calls_group_invite_controller.h
    calls/group/calls_group_members.cpp
    calls/group/calls_group_members.h
    calls/group/calls_group_members_row.cpp
    calls/group/calls_group_members_row.h
    calls/group/calls_group_menu.cpp
    calls/group/calls_group_menu.h
    calls/group/calls_group_panel.cpp
    calls/group/calls_group_panel.h
    calls/group/calls_group_settings.cpp
    calls/group/calls_group_settings.h
    calls/group/calls_group_toasts.cpp
    calls/group/calls_group_toasts.h
    calls/group/calls_group_viewport.cpp
    calls/group/calls_group_viewport.h
    calls/group/calls_group_viewport_opengl.cpp
    calls/group/calls_group_viewport_opengl.h
    calls/group/calls_group_viewport_raster.cpp
    calls/group/calls_group_viewport_raster.h
    calls/group/calls_group_viewport_tile.cpp
    calls/group/calls_group_viewport_tile.h
    calls/group/calls_volume_item.cpp
    calls/group/calls_volume_item.h
    calls/calls_box_controller.cpp
    calls/calls_box_controller.h
    calls/calls_call.cpp
    calls/calls_call.h
    calls/calls_emoji_fingerprint.cpp
    calls/calls_emoji_fingerprint.h
    calls/calls_instance.cpp
    calls/calls_instance.h
    calls/calls_panel.cpp
    calls/calls_panel.h
    calls/calls_signal_bars.cpp
    calls/calls_signal_bars.h
    calls/calls_top_bar.cpp
    calls/calls_top_bar.h
    calls/calls_userpic.cpp
    calls/calls_userpic.h
    calls/calls_video_bubble.cpp
    calls/calls_video_bubble.h
    calls/calls_video_incoming.cpp
    calls/calls_video_incoming.h
    chat_helpers/bot_command.cpp
    chat_helpers/bot_command.h
    chat_helpers/bot_keyboard.cpp
    chat_helpers/bot_keyboard.h
    chat_helpers/emoji_interactions.cpp
    chat_helpers/emoji_interactions.h
    chat_helpers/emoji_keywords.cpp
    chat_helpers/emoji_keywords.h
    chat_helpers/emoji_list_widget.cpp
    chat_helpers/emoji_list_widget.h
    chat_helpers/emoji_sets_manager.cpp
    chat_helpers/emoji_sets_manager.h
    chat_helpers/emoji_suggestions_widget.cpp
    chat_helpers/emoji_suggestions_widget.h
    chat_helpers/field_autocomplete.cpp
    chat_helpers/field_autocomplete.h
    chat_helpers/gifs_list_widget.cpp
    chat_helpers/gifs_list_widget.h
    chat_helpers/message_field.cpp
    chat_helpers/message_field.h
    chat_helpers/send_context_menu.cpp
    chat_helpers/send_context_menu.h
    chat_helpers/spellchecker_common.cpp
    chat_helpers/spellchecker_common.h
    chat_helpers/stickers_emoji_image_loader.cpp
    chat_helpers/stickers_emoji_image_loader.h
    chat_helpers/stickers_emoji_pack.cpp
    chat_helpers/stickers_emoji_pack.h
    chat_helpers/stickers_dice_pack.cpp
    chat_helpers/stickers_dice_pack.h
    chat_helpers/stickers_list_widget.cpp
    chat_helpers/stickers_list_widget.h
    chat_helpers/stickers_lottie.cpp
    chat_helpers/stickers_lottie.h
    chat_helpers/tabbed_panel.cpp
    chat_helpers/tabbed_panel.h
    chat_helpers/tabbed_section.cpp
    chat_helpers/tabbed_section.h
    chat_helpers/tabbed_selector.cpp
    chat_helpers/tabbed_selector.h
    core/application.cpp
    core/application.h
    core/base_integration.cpp
    core/base_integration.h
    core/changelogs.cpp
    core/changelogs.h
    core/click_handler_types.cpp
    core/click_handler_types.h
    core/core_cloud_password.cpp
    core/core_cloud_password.h
    core/core_settings.cpp
    core/core_settings.h
    core/core_settings_proxy.cpp
    core/core_settings_proxy.h
    core/crash_report_window.cpp
    core/crash_report_window.h
    core/crash_reports.cpp
    core/crash_reports.h
    core/file_utilities.cpp
    core/file_utilities.h

=== Telegram/lib_base/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

add_library(lib_base STATIC)
add_library(desktop-app::lib_base ALIAS lib_base)
init_target(lib_base)

add_library(lib_base_crash_report_writer STATIC)
add_library(desktop-app::lib_base_crash_report_writer ALIAS lib_base_crash_report_writer)
init_target(lib_base_crash_report_writer)

get_filename_component(src_loc . REALPATH)

target_precompile_headers(lib_base PRIVATE ${src_loc}/base/base_pch.h)
nice_target_sources(lib_base ${src_loc}
PRIVATE
    base/platform/linux/base_file_utilities_linux.cpp
    base/platform/linux/base_file_utilities_linux.h
    base/platform/linux/base_global_shortcuts_linux.cpp
    base/platform/linux/base_global_shortcuts_linux.h
    base/platform/linux/base_info_linux.cpp
    base/platform/linux/base_info_linux.h
    base/platform/linux/base_last_input_linux.cpp
    base/platform/linux/base_last_input_linux.h
    base/platform/linux/base_layout_switch_linux.cpp
    base/platform/linux/base_layout_switch_linux.h
    base/platform/linux/base_linux_allocation_tracer.cpp
    base/platform/linux/base_linux_allocation_tracer.h
    base/platform/linux/base_linux_dbus_utilities.cpp
    base/platform/linux/base_linux_dbus_utilities.h
    base/platform/linux/base_linux_glibmm_helper.h
    base/platform/linux/base_linux_library.cpp
    base/platform/linux/base_linux_library.h
    base/platform/linux/base_linux_xcb_utilities.cpp
    base/platform/linux/base_linux_xcb_utilities.h
    base/platform/linux/base_linux_xdp_utilities.cpp
    base/platform/linux/base_linux_xdp_utilities.h
    base/platform/linux/base_linux_xsettings.cpp
    base/platform/linux/base_linux_xsettings.h
    base/platform/linux/base_network_reachability_linux.cpp
    base/platform/linux/base_process_linux.cpp
    base/platform/linux/base_process_linux.h
    base/platform/linux/base_system_media_controls_linux_dummy.cpp
    base/platform/linux/base_system_media_controls_linux.cpp
    base/platform/linux/base_url_scheme_linux.cpp
    base/platform/linux/base_url_scheme_linux.h
    base/platform/mac/base_file_utilities_mac.h
    base/platform/mac/base_file_utilities_mac.mm
    base/platform/mac/base_global_shortcuts_mac.mm
    base/platform/mac/base_global_shortcuts_mac.h
    base/platform/mac/base_info_mac.h
    base/platform/mac/base_info_mac.mm
    base/platform/mac/base_last_input_mac.h
    base/platform/mac/base_last_input_mac.mm
    base/platform/mac/base_layout_switch_mac.h
    base/platform/mac/base_layout_switch_mac.mm
    base/platform/mac/base_network_reachability_mac.mm
    base/platform/mac/base_process_mac.h
    base/platform/mac/base_process_mac.mm
    base/platform/mac/base_system_media_controls_mac.mm
    base/platform/mac/base_url_scheme_mac.h
    base/platform/mac/base_url_scheme_mac.mm
    base/platform/mac/base_utilities_mac.h
    base/platform/mac/base_utilities_mac.mm
    base/platform/win/base_file_utilities_win.cpp
    base/platform/win/base_file_utilities_win.h
    base/platform/win/base_global_shortcuts_win.cpp
    base/platform/win/base_global_shortcuts_win.h
    base/platform/win/base_info_win.cpp
    base/platform/win/base_info_win.h
    base/platform/win/base_last_input_win.cpp
    base/platform/win/base_last_input_win.h
    base/platform/win/base_layout_switch_win.cpp
    base/platform/win/base_layout_switch_win.h
    base/platform/win/base_network_reachability_win.cpp
    base/platform/win/base_process_win.cpp
    base/platform/win/base_process_win.h
    base/platform/win/base_system_media_controls_win.cpp
    base/platform/win/base_url_scheme_win.cpp
    base/platform/win/base_url_scheme_win.h
    base/platform/win/base_windows_co_task_mem.h
    base/platform/win/base_windows_h.h
    base/platform/win/base_windows_safe_library.cpp
    base/platform/win/base_windows_safe_library.h
    base/platform/win/base_windows_winrt.cpp
    base/platform/win/base_windows_winrt.h
    base/platform/win/base_windows_wrl.cpp
    base/platform/win/base_windows_wrl.h
    base/platform/win/wrl/wrl_implements_h.h
    base/platform/win/wrl/wrl_module_h.h
    base/platform/base_platform_global_shortcuts.h
    base/platform/base_platform_info.h
    base/platform/base_platform_last_input.h
    base/platform/base_platform_layout_switch.h
    base/platform/base_platform_network_reachability.cpp
    base/platform/base_platform_network_reachability.h
    base/platform/base_platform_file_utilities.h
    base/platform/base_platform_process.h
    base/platform/base_platform_url_scheme.h
    base/platform/base_platform_system_media_controls.h
    base/algorithm.cpp
    base/algorithm.h
    base/assertion.cpp
    base/assertion.h
    base/base_file_utilities.cpp
    base/base_file_utilities.h
    base/basic_types.h
    base/binary_guard.h
    base/build_config.h
    base/bytes.cpp
    base/bytes.h
    base/call_delayed.cpp
    base/call_delayed.h
    base/crc32hash.cpp
    base/crc32hash.h
    base/concurrent_timer.cpp
    base/concurrent_timer.h
    base/const_string.h
    base/debug_log.cpp
    base/debug_log.h
    base/enum_mask.h
    base/event_filter.cpp
    base/event_filter.h
    base/expected.h
    base/file_lock.h
    base/file_lock_win.cpp
    base/file_lock_posix.cpp
    base/flags.h
    base/flat_map.h
    base/flat_set.h
    base/functors.h
    base/global_shortcuts.h
    base/global_shortcuts_generic.cpp
    base/global_shortcuts_generic.h
    base/index_based_iterator.h
    base/integration.cpp
    base/integration.h
    base/invoke_queued.h
    base/last_used_cache.h
    base/last_user_input.cpp
    base/last_user_input.h
    base/match_method.h
    base/network_reachability.cpp
    base/network_reachability.h
    base/object_ptr.h
    base/observer.cpp
    base/observer.h
    base/ordered_set.h
    base/openssl_help.h
    base/optional.h
    base/overload.h
    base/parse_helper.cpp
    base/parse_helper.h
    base/qthelp_regex.h
    base/qthelp_url.cpp
    base/qthelp_url.h
    base/qt_connection.h
    base/qt_signal_producer.h
    base/random.cpp
    base/random.h
    base/required.h
    base/runtime_composer.cpp
    base/runtime_composer.h
    base/single_instance.cpp
    base/single_instance.h
    base/thread_safe_wrap.h
    base/timer.cpp
    base/timer.h
    base/timer_rpl.h
    base/type_traits.h
    base/unique_any.h
    base/unique_function.h
    base/unique_qptr.h
    base/unixtime.cpp
    base/unixtime.h
    base/value_ordering.h
    base/variant.h
    base/virtual_method.h
    base/weak_ptr.h
    base/zlib_help.h

    base/base_pch.h
)

if (DESKTOP_APP_DISABLE_DBUS_INTEGRATION)
    remove_target_sources(lib_base ${src_loc}
        base/platform/linux/base_linux_dbus_utilities.cpp
        base/platform/linux/base_linux_dbus_utilities.h
        base/platform/linux/base_linux_glibmm_helper.h
        base/platform/linux/base_linux_xdp_utilities.cpp
        base/platform/linux/base_linux_xdp_utilities.h
        base/platform/linux/base_system_media_controls_linux.cpp
    )
else()
    remove_target_sources(lib_base ${src_loc}
        base/platform/linux/base_system_media_controls_linux_dummy.cpp
    )
endif()

if (DESKTOP_APP_DISABLE_X11_INTEGRATION)
    remove_target_sources(lib_base ${src_loc}
        base/platform/linux/base_linux_xcb_utilities.cpp
        base/platform/linux/base_linux_xcb_utilities.h
        base/platform/linux/base_linux_xsettings.cpp
        base/platform/linux/base_linux_xsettings.h
    )
endif()

target_include_directories(lib_base
PUBLIC
    ${src_loc}
)

target_link_libraries(lib_base
PUBLIC
    desktop-app::lib_rpl
    desktop-app::lib_crl
    desktop-app::external_qt
    desktop-app::external_openssl
    desktop-app::external_crash_reports
    desktop-app::external_ranges
    desktop-app::external_gsl
    desktop-app::external_expected
)

if (WIN32)
    nuget_add_winrt(lib_base)
elseif (LINUX)
    if (NOT DESKTOP_APP_DISABLE_DBUS_INTEGRATION)
        target_link_libraries(lib_base
        PUBLIC
            desktop-app::external_glibmm
            desktop-app::external_glib
        )
    endif()

    if (NOT DESKTOP_APP_DISABLE_X11_INTEGRATION)
        target_link_libraries(lib_base
        PUBLIC
            desktop-app::external_xcb_keysyms
            desktop-app::external_xcb_record
            desktop-app::external_xcb_screensaver
            desktop-app::external_xcb
        )
    endif()
endif()

if (DESKTOP_APP_USE_ALLOCATION_TRACER)
    target_compile_definitions(lib_base
    PRIVATE
        DESKTOP_APP_USE_ALLOCATION_TRACER
    )
endif()

#target_precompile_headers(lib_base_crash_report_writer REUSE_FROM lib_base)
target_precompile_headers(lib_base_crash_report_writer PRIVATE ${src_loc}/base/base_pch.h)
nice_target_sources(lib_base_crash_report_writer ${src_loc}
PRIVATE
    base/crash_report_header.cpp
    base/crash_report_header.h
    base/crash_report_writer.cpp
    base/crash_report_writer.h
)

target_link_libraries(lib_base_crash_report_writer PUBLIC desktop-app::lib_base)

=== Telegram/lib_crl/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

add_library(lib_crl OBJECT)
add_library(desktop-app::lib_crl ALIAS lib_crl)
init_target(lib_crl)

get_filename_component(src_loc . REALPATH)

nice_target_sources(lib_crl ${src_loc}
PRIVATE
    crl/common/crl_common_config.h
    crl/common/crl_common_fp_exceptions.cpp
    crl/common/crl_common_guards.h
    crl/common/crl_common_list.cpp
    crl/common/crl_common_list.h
    crl/common/crl_common_object_async.h
    crl/common/crl_common_on_main.cpp
    crl/common/crl_common_on_main.h
    crl/common/crl_common_on_main_guarded.h
    crl/common/crl_common_queue.cpp
    crl/common/crl_common_queue.h
    crl/common/crl_common_sync.h
    crl/common/crl_common_utils.h
    crl/dispatch/crl_dispatch_async.cpp
    crl/dispatch/crl_dispatch_async.h
    crl/dispatch/crl_dispatch_on_main.h
    crl/dispatch/crl_dispatch_queue.cpp
    crl/dispatch/crl_dispatch_queue.h
    crl/dispatch/crl_dispatch_semaphore.cpp
    crl/dispatch/crl_dispatch_semaphore.h
    crl/mac/crl_mac_time.cpp
    crl/linux/crl_linux_time.cpp
    crl/qt/crl_qt_async.cpp
    crl/qt/crl_qt_async.h
    crl/qt/crl_qt_guards.h
    crl/qt/crl_qt_semaphore.cpp
    crl/qt/crl_qt_semaphore.h
    crl/winapi/crl_winapi_async.cpp
    crl/winapi/crl_winapi_async.h
    crl/winapi/crl_winapi_dll.h
    crl/winapi/crl_winapi_fp_exceptions.cpp
    crl/winapi/crl_winapi_list.cpp
    crl/winapi/crl_winapi_list.h
    crl/winapi/crl_winapi_semaphore.cpp
    crl/winapi/crl_winapi_semaphore.h
    crl/winapi/crl_winapi_time.cpp
    crl/winapi/crl_winapi_windows_h.h
    crl/crl.h
    crl/crl_async.h
    crl/crl_fp_exceptions.h
    crl/crl_object_on_queue.h
    crl/crl_object_on_thread.cpp
    crl/crl_object_on_thread.h
    crl/crl_on_main.h
    crl/crl_queue.h
    crl/crl_semaphore.h
    crl/crl_time.cpp
    crl/crl_time.h
)

target_include_directories(lib_crl
PUBLIC
    ${src_loc}
)

if (TARGET desktop-app::external_dispatch)
    target_link_libraries(lib_crl
    PUBLIC
        desktop-app::external_dispatch
    )
endif()

if (LINUX)
    target_link_libraries(lib_crl
    PUBLIC
        pthread
    )
endif()

if (build_macstore OR TARGET desktop-app::external_dispatch)
    target_compile_definitions(lib_crl
    PUBLIC
        CRL_USE_COMMON_QUEUE
    )
endif()

target_link_libraries(lib_crl
PUBLIC
    desktop-app::external_qt
)

=== Telegram/lib_ui/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

add_library(lib_ui STATIC)
add_library(desktop-app::lib_ui ALIAS lib_ui)
init_target(lib_ui)

include(cmake/generate_palette.cmake)
include(cmake/generate_styles.cmake)
include(cmake/generate_emoji.cmake)

get_filename_component(src_loc . REALPATH)

set(style_files
    ui/basic.style
    ui/layers/layers.style
    ui/widgets/widgets.style
)

generate_palette(lib_ui ui/colors.palette)
generate_styles(lib_ui ${src_loc} "${style_files}" ui/colors.palette)
generate_emoji(lib_ui emoji.txt emoji_suggestions/emoji_autocomplete.json)

set_target_properties(lib_ui PROPERTIES AUTOMOC ON)
target_prepare_qrc(lib_ui)

target_precompile_headers(lib_ui PRIVATE ${src_loc}/ui/ui_pch.h)
nice_target_sources(lib_ui ${src_loc}
PRIVATE
    ${style_files}
    ui/colors.palette
    emoji_suggestions/emoji_autocomplete.json

    qt_conf/win.qrc

    ui/effects/animation_value.cpp
    ui/effects/animation_value.h
    ui/effects/animations.cpp
    ui/effects/animations.h
    ui/effects/cross_animation.cpp
    ui/effects/cross_animation.h
    ui/effects/cross_line.cpp
    ui/effects/cross_line.h
    ui/effects/fade_animation.cpp
    ui/effects/fade_animation.h
    ui/effects/gradient.h
    ui/effects/numbers_animation.cpp
    ui/effects/numbers_animation.h
    ui/effects/panel_animation.cpp
    ui/effects/panel_animation.h
    ui/effects/path_shift_gradient.cpp
    ui/effects/path_shift_gradient.h
    ui/effects/radial_animation.cpp
    ui/effects/radial_animation.h
    ui/effects/ripple_animation.cpp
    ui/effects/ripple_animation.h
    ui/effects/slide_animation.cpp
    ui/effects/slide_animation.h
    ui/gl/gl_detection.cpp
    ui/gl/gl_detection.h
    ui/gl/gl_image.cpp
    ui/gl/gl_image.h
    ui/gl/gl_math.cpp
    ui/gl/gl_math.h
    ui/gl/gl_primitives.cpp
    ui/gl/gl_primitives.h
    ui/gl/gl_shader.cpp
    ui/gl/gl_shader.h
    ui/gl/gl_surface.cpp
    ui/gl/gl_surface.h
    ui/gl/gl_window.cpp
    ui/gl/gl_window.h
    ui/image/image_prepare.cpp
    ui/image/image_prepare.h
    ui/layers/box_content.cpp
    ui/layers/box_content.h
    ui/layers/box_layer_widget.cpp
    ui/layers/box_layer_widget.h
    ui/layers/generic_box.cpp
    ui/layers/generic_box.h
    ui/layers/layer_manager.cpp
    ui/layers/layer_manager.h
    ui/layers/layer_widget.cpp
    ui/layers/layer_widget.h
    ui/paint/arcs.cpp
    ui/paint/arcs.h
    ui/paint/blob.cpp
    ui/paint/blob.h
    ui/paint/blobs.cpp
    ui/paint/blobs.h
    ui/paint/blobs_linear.cpp
    ui/paint/blobs_linear.h
    ui/platform/linux/ui_linux_wayland_integration.cpp
    ui/platform/linux/ui_linux_wayland_integration.h
    ui/platform/linux/ui_window_linux.cpp
    ui/platform/linux/ui_window_linux.h
    ui/platform/linux/ui_utility_linux.cpp
    ui/platform/linux/ui_utility_linux.h
    ui/platform/mac/ui_window_mac.h
    ui/platform/mac/ui_window_mac.mm
    ui/platform/mac/ui_window_title_mac.h
    ui/platform/mac/ui_window_title_mac.mm
    ui/platform/mac/ui_utility_mac.h
    ui/platform/mac/ui_utility_mac.mm
    ui/platform/win/ui_window_shadow_win.cpp
    ui/platform/win/ui_window_shadow_win.h
    ui/platform/win/ui_window_title_win.cpp
    ui/platform/win/ui_window_title_win.h
    ui/platform/win/ui_window_win.cpp
    ui/platform/win/ui_window_win.h
    ui/platform/win/ui_utility_win.cpp
    ui/platform/win/ui_utility_win.h
    ui/platform/ui_platform_window_title.cpp
    ui/platform/ui_platform_window_title.h
    ui/platform/ui_platform_window.cpp
    ui/platform/ui_platform_window.h
    ui/platform/ui_platform_utility.cpp
    ui/platform/ui_platform_utility.h
    ui/style/style_core.cpp
    ui/style/style_core.h
    ui/style/style_core_color.cpp
    ui/style/style_core_color.h
    ui/style/style_core_custom_font.cpp
    ui/style/style_core_custom_font.h
    ui/style/style_core_direction.cpp
    ui/style/style_core_direction.h
    ui/style/style_core_font.cpp
    ui/style/style_core_font.h
    ui/style/style_core_icon.cpp
    ui/style/style_core_icon.h
    ui/style/style_core_palette.cpp
    ui/style/style_core_palette.h
    ui/style/style_core_scale.cpp
    ui/style/style_core_scale.h
    ui/style/style_core_types.cpp
    ui/style/style_core_types.h
    ui/style/style_palette_colorizer.cpp
    ui/style/style_palette_colorizer.h
    ui/text/text.cpp
    ui/text/text.h
    ui/text/text_block.cpp
    ui/text/text_block.h
    ui/text/text_entity.cpp
    ui/text/text_entity.h
    ui/text/text_isolated_emoji.h
    ui/text/text_utilities.cpp
    ui/text/text_utilities.h
    ui/toast/toast.cpp
    ui/toast/toast.h
    ui/toast/toast_manager.cpp
    ui/toast/toast_manager.h
    ui/toast/toast_widget.cpp
    ui/toast/toast_widget.h
    ui/widgets/box_content_divider.cpp
    ui/widgets/box_content_divider.h
    ui/widgets/buttons.cpp
    ui/widgets/buttons.h
    ui/widgets/call_button.cpp
    ui/widgets/call_button.h
    ui/widgets/checkbox.cpp
    ui/widgets/checkbox.h
    ui/widgets/dropdown_menu.cpp
    ui/widgets/dropdown_menu.h
    ui/widgets/inner_dropdown.cpp
    ui/widgets/inner_dropdown.h
    ui/widgets/input_fields.cpp
    ui/widgets/input_fields.h
    ui/widgets/labels.cpp
    ui/widgets/labels.h
    ui/widgets/menu/menu.cpp
    ui/widgets/menu/menu.h
    ui/widgets/menu/menu_action.cpp
    ui/widgets/menu/menu_action.h
    ui/widgets/menu/menu_common.cpp
    ui/widgets/menu/menu_common.h
    ui/widgets/menu/menu_item_base.cpp
    ui/widgets/menu/menu_item_base.h
    ui/widgets/menu/menu_separator.cpp
    ui/widgets/menu/menu_separator.h
    ui/widgets/menu/menu_toggle.cpp
    ui/widgets/menu/menu_toggle.h
    ui/widgets/popup_menu.cpp
    ui/widgets/popup_menu.h
    ui/widgets/rp_window.cpp
    ui/widgets/rp_window.h
    ui/widgets/scroll_area.cpp
    ui/widgets/scroll_area.h
    ui/widgets/side_bar_button.cpp
    ui/widgets/side_bar_button.h
    ui/widgets/shadow.cpp
    ui/widgets/shadow.h
    ui/widgets/time_input.cpp
    ui/widgets/time_input.h
    ui/widgets/tooltip.cpp
    ui/widgets/tooltip.h
    ui/wrap/fade_wrap.cpp
    ui/wrap/fade_wrap.h
    ui/wrap/padding_wrap.cpp
    ui/wrap/padding_wrap.h
    ui/wrap/slide_wrap.cpp
    ui/wrap/slide_wrap.h
    ui/wrap/vertical_layout.cpp
    ui/wrap/vertical_layout.h
    ui/wrap/vertical_layout_reorder.cpp
    ui/wrap/vertical_layout_reorder.h
    ui/wrap/wrap.h
    ui/abstract_button.cpp
    ui/abstract_button.h
    ui/basic_click_handlers.cpp
    ui/basic_click_handlers.h
    ui/click_handler.cpp
    ui/click_handler.h
    ui/delayed_activation.cpp
    ui/delayed_activation.h
    ui/emoji_config.cpp
    ui/emoji_config.h
    ui/focus_persister.h
    ui/inactive_press.cpp
    ui/inactive_press.h
    ui/integration.cpp
    ui/integration.h
    ui/main_queue_processor.cpp
    ui/main_queue_processor.h
    ui/painter.h
    ui/ph.cpp
    ui/ph.h
    ui/rect_part.h
    ui/round_rect.cpp
    ui/round_rect.h
    ui/spoiler_click_handler.cpp
    ui/spoiler_click_handler.h
    ui/rp_widget.cpp
    ui/rp_widget.h
    ui/ui_utility.cpp
    ui/ui_utility.h

    ui/ui_pch.h

    emoji_suggestions/emoji_suggestions.cpp
    emoji_suggestions/emoji_suggestions.h
    emoji_suggestions/emoji_suggestions_helper.h
)

if (DESKTOP_APP_USE_PACKAGED)
    nice_target_sources(lib_ui ${src_loc} PRIVATE ui/text/qtextitemint.cpp)
endif()

if (NOT DESKTOP_APP_USE_PACKAGED_FONTS)
    nice_target_sources(lib_ui ${src_loc} PRIVATE fonts/fonts.qrc)
endif()

if (DESKTOP_APP_DISABLE_WAYLAND_INTEGRATION)
    remove_target_sources(Telegram ${src_loc} ui/platform/linux/ui_linux_wayland_integration.cpp)
    nice_target_sources(Telegram ${src_loc} PRIVATE ui/platform/linux/ui_linux_wayland_integration_dummy.cpp)
elseif(LINUX)
    target_link_libraries(lib_ui
    PUBLIC
        desktop-app::lib_waylandshells
        desktop-app::external_kwayland
    )
endif()

target_include_directories(lib_ui
PUBLIC
    ${src_loc}
    ${src_loc}/emoji_suggestions
)

target_link_libraries(lib_ui
PUBLIC
    desktop-app::lib_base
PRIVATE
    desktop-app::external_zlib
)

=== Telegram/lib_webview/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

add_library(lib_webview STATIC)
add_library(desktop-app::lib_webview ALIAS lib_webview)
init_target(lib_webview)

get_filename_component(src_loc . REALPATH)

nice_target_sources(lib_webview ${src_loc}
PRIVATE
    webview/webview_embed.cpp
    webview/webview_embed.h
    webview/webview_interface.h

    webview/platform/mac/webview_mac.h
    webview/platform/mac/webview_mac.mm

    webview/platform/linux/webview_linux.h
    webview/platform/linux/webview_linux.cpp
    webview/platform/linux/webview_linux_webkit_gtk.cpp
    webview/platform/linux/webview_linux_webkit_gtk.h
    webview/platform/linux/webview_linux_webkit2gtk.cpp
    webview/platform/linux/webview_linux_webkit2gtk_dummy.cpp
    webview/platform/linux/webview_linux_webkit2gtk.h

    webview/platform/win/webview_win.cpp
    webview/platform/win/webview_win.h
    webview/platform/win/webview_windows_edge_chromium.cpp
    webview/platform/win/webview_windows_edge_chromium.h
    webview/platform/win/webview_windows_edge_html.cpp
    webview/platform/win/webview_windows_edge_html.h
)

target_include_directories(lib_webview
PUBLIC
    ${src_loc}
)

target_link_libraries(lib_webview
PUBLIC
    desktop-app::lib_base
)

if (WIN32)
    nuget_add_webview(lib_webview)
    nuget_add_winrt(lib_webview)
elseif (LINUX)
    if (DESKTOP_APP_DISABLE_DBUS_INTEGRATION)
        remove_target_sources(lib_webview ${src_loc}
            webview/platform/linux/webview_linux_webkit_gtk.cpp
            webview/platform/linux/webview_linux_webkit_gtk.h
            webview/platform/linux/webview_linux_webkit2gtk.cpp
        )
    else()
        remove_target_sources(lib_webview ${src_loc}
            webview/platform/linux/webview_linux_webkit2gtk_dummy.cpp
        )

        target_link_libraries(lib_webview PUBLIC ${CMAKE_DL_LIBS})
    endif()
endif()

=== cmake/external/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

macro(add_checked_subdirectory name)
    if (NOT DEFINED desktop_app_skip_libs
        OR NOT ${name} IN_LIST desktop_app_skip_libs)
        add_subdirectory(${name})
    endif()
endmacro()

add_checked_subdirectory(angle)
add_checked_subdirectory(auto_updates)
add_checked_subdirectory(crash_reports)
if (LINUX AND NOT DESKTOP_APP_DISABLE_DBUS_INTEGRATION)
    add_checked_subdirectory(dbusmenu_qt)
endif()
if (LINUX)
    add_checked_subdirectory(dispatch)
endif()
add_checked_subdirectory(expected)
if (LINUX AND NOT DESKTOP_APP_DISABLE_DBUS_INTEGRATION)
    add_checked_subdirectory(fcitx_qt5)
    if (NOT DESKTOP_APP_DISABLE_X11_INTEGRATION)
        add_checked_subdirectory(fcitx5_qt)
    endif()
endif()
add_checked_subdirectory(ffmpeg)
if (LINUX AND NOT DESKTOP_APP_DISABLE_DBUS_INTEGRATION)
    add_checked_subdirectory(glib)
    add_checked_subdirectory(glibmm)
endif()
add_checked_subdirectory(gsl)
if (LINUX AND NOT DESKTOP_APP_DISABLE_X11_INTEGRATION)
    add_checked_subdirectory(hime_qt)
endif()
if (add_hunspell_library)
	add_checked_subdirectory(hunspell)
endif()
add_checked_subdirectory(iconv)
if (LINUX)
    add_checked_subdirectory(jemalloc)
endif()
add_checked_subdirectory(jpeg)
if (LINUX AND NOT DESKTOP_APP_DISABLE_WAYLAND_INTEGRATION)
    add_checked_subdirectory(kwayland)
endif()
add_checked_subdirectory(lz4)
add_checked_subdirectory(minizip)
if (LINUX)
    add_checked_subdirectory(nimf_qt5)
endif()
add_checked_subdirectory(openal)
add_checked_subdirectory(openssl)
add_checked_subdirectory(opus)
add_checked_subdirectory(qt)
add_checked_subdirectory(qr_code_generator)
add_checked_subdirectory(ranges)
add_checked_subdirectory(rlottie)
add_checked_subdirectory(rnnoise)
if (LINUX AND NOT DESKTOP_APP_DISABLE_DBUS_INTEGRATION)
    add_checked_subdirectory(statusnotifieritem)
endif()
add_checked_subdirectory(ton)
add_checked_subdirectory(variant)
add_checked_subdirectory(webrtc)
if (LINUX AND NOT DESKTOP_APP_DISABLE_X11_INTEGRATION)
    add_checked_subdirectory(xcb)
endif()
add_checked_subdirectory(xxhash)
add_checked_subdirectory(zlib)

=== Telegram/ThirdParty/libtgvoip/CMakeLists.txt ===
# This file was written from scratch by Nicholas Guriev for the libtgvoip package.
# You may use this code as you wish under the terms of UNLICENSE, see https://unlicense.org/

cmake_minimum_required(VERSION 3.16)
project(libtgvoip)
include(GNUInstallDirs)
set(DESKTOP_APP_USE_PACKAGED TRUE)

include(cmake/validate_special_target.cmake)
include(cmake/init_target.cmake)
include(cmake/nice_target_sources.cmake)
include(cmake/options.cmake)
add_subdirectory(cmake/external/opus)
add_subdirectory(cmake/external/webrtc)

set(DESKTOP_APP_USE_PACKAGED FALSE)
set(TGVOIP_FOUND FALSE)
set(tgvoip_loc "${CMAKE_SOURCE_DIR}")
include(lib_tgvoip.cmake)
set_target_properties(lib_tgvoip_bundled PROPERTIES OUTPUT_NAME tgvoip PUBLIC_HEADER TgVoip.h)
install(TARGETS lib_tgvoip_bundled PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/tgvoip")

set(LIBTGVOIP_VERSION 2.4.4)
configure_file(tgvoip.pc.in tgvoip.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/tgvoip.pc DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")

=== cmake/external/dbusmenu_qt/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

add_library(external_dbusmenu_qt INTERFACE IMPORTED GLOBAL)
add_library(desktop-app::external_dbusmenu_qt ALIAS external_dbusmenu_qt)

if (DESKTOP_APP_USE_PACKAGED AND NOT DESKTOP_APP_QT6)
    if (DESKTOP_APP_USE_PACKAGED_LAZY)
        find_package(dbusmenu-qt5 QUIET)
    else()
        find_package(dbusmenu-qt5)
    endif()

    if (dbusmenu-qt5_FOUND)
        target_link_libraries(external_dbusmenu_qt INTERFACE dbusmenu-qt5)
    endif()
endif()

if (NOT dbusmenu-qt5_FOUND)
    add_library(external_dbusmenu_qt_bundled STATIC)
    init_target(external_dbusmenu_qt_bundled "(external)")

    set(dbusmenu_qt_VERSION_MAJOR 0)
    set(dbusmenu_qt_VERSION_MINOR 9)
    set(dbusmenu_qt_VERSION_PATCH 2)

    set(dbusmenu_qt_loc ${third_party_loc}/libdbusmenu-qt/src)

    set_target_properties(external_dbusmenu_qt_bundled PROPERTIES AUTOMOC ON)

    # QIcon::name was introduced in Qt 4.7.
    set(HAVE_QICON_NAME ON)

    configure_file(${dbusmenu_qt_loc}/dbusmenu_config.h.in "${CMAKE_CURRENT_BINARY_DIR}/dbusmenu_config.h" @ONLY)
    configure_file(${dbusmenu_qt_loc}/dbusmenu_version.h.in "${CMAKE_CURRENT_BINARY_DIR}/dbusmenu_version.h")

    nice_target_sources(external_dbusmenu_qt_bundled ${dbusmenu_qt_loc}
    PRIVATE
        dbusmenu_p.cpp
        dbusmenuexporter.cpp
        dbusmenuexporterdbus_p.cpp
        dbusmenuimporter.cpp
        dbusmenutypes_p.cpp
        dbusmenushortcut_p.cpp
        utils.cpp
    )

    if (DESKTOP_APP_QT6)
        qt6_add_dbus_adaptor(dbusmenu_adaptor
            ${dbusmenu_qt_loc}/com.canonical.dbusmenu.xml
            ${dbusmenu_qt_loc}/dbusmenuexporterdbus_p.h
            DBusMenuExporterDBus
        )
    else()
        qt5_add_dbus_adaptor(dbusmenu_adaptor
            ${dbusmenu_qt_loc}/com.canonical.dbusmenu.xml
            ${dbusmenu_qt_loc}/dbusmenuexporterdbus_p.h
            DBusMenuExporterDBus
        )
    endif()

    target_sources(external_dbusmenu_qt_bundled PRIVATE ${dbusmenu_adaptor})

    target_include_directories(external_dbusmenu_qt_bundled
    PUBLIC
        ${dbusmenu_qt_loc}
        "${CMAKE_CURRENT_BINARY_DIR}"
    )

    target_link_libraries(external_dbusmenu_qt_bundled
    PRIVATE
        desktop-app::external_qt
    )

    target_link_libraries(external_dbusmenu_qt
    INTERFACE
        external_dbusmenu_qt_bundled
    )
endif()

=== cmake/external/dispatch/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

set(dispatch_loc ${third_party_loc}/dispatch)
set(dispatch_prefix ${CMAKE_CURRENT_BINARY_DIR}/dispatch-prefix)
set(dispatch_binary_dir ${dispatch_prefix}/src/dispatch-build)

if (DESKTOP_APP_USE_PACKAGED)
    find_library(DISPATCH_LIBRARIES dispatch)
    find_path(DISPATCH_INCLUDE_DIRS dispatch/dispatch.h)
endif()

if (NOT DISPATCH_LIBRARIES OR NOT DISPATCH_INCLUDE_DIRS)
    execute_process(
        COMMAND ${CMAKE_COMMAND} ${dispatch_loc}
            -B ${dispatch_binary_dir}
            -GNinja
            -DCMAKE_BUILD_TYPE=Release
            -DCMAKE_C_COMPILER=clang
            -DCMAKE_CXX_COMPILER=clang++
            -DBUILD_SHARED_LIBS=OFF
            -DBUILD_TESTING=OFF
    )

    execute_process(
        COMMAND ${CMAKE_COMMAND} --build ${dispatch_binary_dir}
    )

    if (NOT EXISTS ${dispatch_binary_dir}/src/libdispatch.a)
        if (DESKTOP_APP_SPECIAL_TARGET)
            message(FATAL_ERROR "Dispatch build failed")
        else()
            return()
        endif()
    endif()
endif()

add_library(external_dispatch INTERFACE IMPORTED GLOBAL)
add_library(desktop-app::external_dispatch ALIAS external_dispatch)

if (DESKTOP_APP_USE_PACKAGED AND DISPATCH_LIBRARIES AND DISPATCH_INCLUDE_DIRS)
    target_include_directories(external_dispatch SYSTEM INTERFACE ${DISPATCH_INCLUDE_DIRS})
    target_link_libraries(external_dispatch INTERFACE ${DISPATCH_LIBRARIES})
    return()
endif()

add_library(external_dispatch_bundled STATIC IMPORTED)

set_target_properties(external_dispatch_bundled PROPERTIES
    IMPORTED_LOCATION "${dispatch_binary_dir}/src/libdispatch.a"
)

target_include_directories(external_dispatch_bundled SYSTEM
INTERFACE
    ${dispatch_loc}
)

target_link_libraries(external_dispatch_bundled
INTERFACE
    ${dispatch_binary_dir}/src/BlocksRuntime/libBlocksRuntime.a
    pthread
)

target_link_libraries(external_dispatch
INTERFACE
    external_dispatch_bundled
)

=== cmake/external/fcitx5_qt/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

if (DESKTOP_APP_USE_PACKAGED AND NOT DESKTOP_APP_USE_PACKAGED_LAZY)
    add_library(external_fcitx5_qt INTERFACE IMPORTED GLOBAL)
    add_library(desktop-app::external_fcitx5_qt ALIAS external_fcitx5_qt)
else()
    add_library(external_fcitx5_qt STATIC)
    add_library(desktop-app::external_fcitx5_qt ALIAS external_fcitx5_qt)
    init_target(external_fcitx5_qt "(external)")

    set(fcitx5_qt_loc ${third_party_loc}/fcitx5-qt)

    if (DESKTOP_APP_QT6)
        set(fcitx5_qt_src ${fcitx5_qt_loc}/qt6/platforminputcontext)
    else()
        set(fcitx5_qt_src ${fcitx5_qt_loc}/qt5/platforminputcontext)
    endif()

    set_target_properties(external_fcitx5_qt PROPERTIES AUTOMOC ON)
    set(FCITX5_QT_EXTRA_PLUGIN_NAME "")

    configure_file("${fcitx5_qt_src}/fcitx5.json.in" "${CMAKE_CURRENT_BINARY_DIR}/fcitx5.json")

    nice_target_sources(external_fcitx5_qt ${fcitx5_qt_src}
    PRIVATE
        qfcitxplatforminputcontext.cpp
        qfcitxplatforminputcontext.h
        fcitxcandidatewindow.cpp
        fcitxcandidatewindow.h
        fcitxtheme.cpp
        fcitxtheme.h
        font.cpp
        font.h
        qtkey.cpp
        main.cpp
        main.h
    )

    target_include_directories(external_fcitx5_qt
    PRIVATE
        ${fcitx5_qt_src}
        ${fcitx5_qt_loc}/common
    )

    target_compile_definitions(external_fcitx5_qt
    PRIVATE
        QT_STATICPLUGIN
        FCITX_PLUGIN_DATA_FILE_PATH="${CMAKE_CURRENT_BINARY_DIR}/fcitx5.json"
    )

    add_subdirectory(fcitx5_qt_dbusaddons)
    target_link_libraries(external_fcitx5_qt
    PRIVATE
        desktop-app::external_fcitx5_qt_dbusaddons
        desktop-app::external_qt
        desktop-app::external_xcb
    )

    if (DESKTOP_APP_USE_PACKAGED)
        find_package(PkgConfig REQUIRED)
        pkg_check_modules(XKBCOMMON REQUIRED IMPORTED_TARGET xkbcommon)

        target_link_libraries(external_fcitx5_qt
        PRIVATE
            PkgConfig::XKBCOMMON
        )
    else()
        find_package(PkgConfig REQUIRED)
        pkg_check_modules(XKBCOMMON REQUIRED xkbcommon)

        target_include_directories(external_fcitx5_qt SYSTEM
        PUBLIC
            ${XKBCOMMON_INCLUDE_DIRS}
        )

        target_link_static_libraries(external_fcitx5_qt
        PRIVATE
            xkbcommon
        )
    endif()
endif()

=== cmake/external/fcitx_qt5/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

if (DESKTOP_APP_USE_PACKAGED AND NOT DESKTOP_APP_USE_PACKAGED_LAZY)
    add_library(external_fcitx_qt5 INTERFACE IMPORTED GLOBAL)
    add_library(desktop-app::external_fcitx_qt5 ALIAS external_fcitx_qt5)
else()
    add_library(external_fcitx_qt5 STATIC)
    add_library(desktop-app::external_fcitx_qt5 ALIAS external_fcitx_qt5)
    init_target(external_fcitx_qt5 "(external)")

    set(fcitx_qt5_loc ${third_party_loc}/fcitx-qt5)

    if (DESKTOP_APP_QT6)
        set(fcitx_qt5_src ${fcitx_qt5_loc}/qt6/platforminputcontext)
    else()
        set(fcitx_qt5_src ${fcitx_qt5_loc}/qt5/platforminputcontext)
    endif()

    set_target_properties(external_fcitx_qt5 PROPERTIES AUTOMOC ON)

    nice_target_sources(external_fcitx_qt5 ${fcitx_qt5_src}
    PRIVATE
        fcitxinputcontextproxy.cpp
        fcitxqtdbustypes.cpp
        fcitxwatcher.cpp
        qfcitxplatforminputcontext.cpp
        main.cpp
        qtkey.cpp
    )

    set_source_files_properties(${fcitx_qt5_src}/org.fcitx.Fcitx.InputContext.xml PROPERTIES
    INCLUDE ${fcitx_qt5_src}/fcitxqtdbustypes.h)
    set_source_files_properties(${fcitx_qt5_src}/org.fcitx.Fcitx.InputContext1.xml PROPERTIES
    INCLUDE ${fcitx_qt5_src}/fcitxqtdbustypes.h)
    set_source_files_properties(${fcitx_qt5_src}/org.fcitx.Fcitx.InputMethod.xml PROPERTIES
    INCLUDE ${fcitx_qt5_src}/fcitxqtdbustypes.h)
    set_source_files_properties(${fcitx_qt5_src}/org.fcitx.Fcitx.InputMethod1.xml PROPERTIES
    INCLUDE ${fcitx_qt5_src}/fcitxqtdbustypes.h)

    if (DESKTOP_APP_QT6)
        qt6_add_dbus_interface(fcitx_qt5_adaptors ${fcitx_qt5_src}/org.fcitx.Fcitx.InputContext.xml inputcontextproxy)
        qt6_add_dbus_interface(fcitx_qt5_adaptors ${fcitx_qt5_src}/org.fcitx.Fcitx.InputContext1.xml inputcontext1proxy)
        qt6_add_dbus_interface(fcitx_qt5_adaptors ${fcitx_qt5_src}/org.fcitx.Fcitx.InputMethod.xml inputmethodproxy)
        qt6_add_dbus_interface(fcitx_qt5_adaptors ${fcitx_qt5_src}/org.fcitx.Fcitx.InputMethod1.xml inputmethod1proxy)
    else()
        qt5_add_dbus_interface(fcitx_qt5_adaptors ${fcitx_qt5_src}/org.fcitx.Fcitx.InputContext.xml inputcontextproxy)
        qt5_add_dbus_interface(fcitx_qt5_adaptors ${fcitx_qt5_src}/org.fcitx.Fcitx.InputContext1.xml inputcontext1proxy)
        qt5_add_dbus_interface(fcitx_qt5_adaptors ${fcitx_qt5_src}/org.fcitx.Fcitx.InputMethod.xml inputmethodproxy)
        qt5_add_dbus_interface(fcitx_qt5_adaptors ${fcitx_qt5_src}/org.fcitx.Fcitx.InputMethod1.xml inputmethod1proxy)
    endif()

    target_sources(external_fcitx_qt5 PRIVATE ${fcitx_qt5_adaptors})

    target_include_directories(external_fcitx_qt5
    PRIVATE
        ${fcitx_qt5_src}
        "${CMAKE_CURRENT_BINARY_DIR}"
    )

    target_compile_definitions(external_fcitx_qt5
    PRIVATE
        QT_STATICPLUGIN
    )

    target_link_libraries(external_fcitx_qt5
    PRIVATE
        desktop-app::external_qt
    )

    if (DESKTOP_APP_USE_PACKAGED)
        find_package(PkgConfig REQUIRED)
        pkg_check_modules(XKBCOMMON REQUIRED IMPORTED_TARGET xkbcommon)

        target_link_libraries(external_fcitx_qt5
        PRIVATE
            PkgConfig::XKBCOMMON
        )
    else()
        target_link_static_libraries(external_fcitx_qt5
        PRIVATE
            xkbcommon
        )
    endif()
endif()

=== cmake/external/ffmpeg/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

add_library(external_ffmpeg INTERFACE IMPORTED GLOBAL)
add_library(desktop-app::external_ffmpeg ALIAS external_ffmpeg)

if (DESKTOP_APP_USE_PACKAGED)
    find_package(PkgConfig REQUIRED)

    pkg_check_modules(AVCODEC REQUIRED IMPORTED_TARGET libavcodec)
    pkg_check_modules(AVFORMAT REQUIRED IMPORTED_TARGET libavformat)
    pkg_check_modules(AVUTIL REQUIRED IMPORTED_TARGET libavutil)
    pkg_check_modules(SWSCALE REQUIRED IMPORTED_TARGET libswscale)
    pkg_check_modules(SWRESAMPLE REQUIRED IMPORTED_TARGET libswresample)

    target_link_libraries(external_ffmpeg
    INTERFACE
        PkgConfig::AVCODEC
        PkgConfig::AVFORMAT
        PkgConfig::AVUTIL
        PkgConfig::SWSCALE
        PkgConfig::SWRESAMPLE
    )
else()
    target_include_directories(external_ffmpeg SYSTEM
    INTERFACE
        ${libs_loc}/ffmpeg
    )

    set(ffmpeg_lib_loc ${libs_loc}/ffmpeg)

    target_link_libraries(external_ffmpeg
    INTERFACE
        ${ffmpeg_lib_loc}/libavformat/libavformat.a
        ${ffmpeg_lib_loc}/libavcodec/libavcodec.a
        ${ffmpeg_lib_loc}/libswresample/libswresample.a
        ${ffmpeg_lib_loc}/libswscale/libswscale.a
        ${ffmpeg_lib_loc}/libavutil/libavutil.a
        $<TARGET_FILE:desktop-app::external_opus>
    )
    if (LINUX)
        target_link_static_libraries(external_ffmpeg
        INTERFACE
            lzma
            va-x11
            va-drm
            va
            vdpau
            Xv
            Xext
            Xfixes
            drm
        )
        target_link_libraries(external_ffmpeg
        INTERFACE
            X11
            pthread
        )
    endif()
endif()

=== debian/changelog ===
telegram-desktop (3.4.3+ds-1~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 19 Jan 2022 13:17:05 -0800

telegram-desktop (3.4.3+ds-1) unstable; urgency=medium

  * New upstream release.
  * Lesser debug info when LTO is enabled.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Tue, 04 Jan 2022 15:24:33 +0300

=== debian/control ===
Source: telegram-desktop
Section: net
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Nicholas Guriev <guriev-ns@ya.ru>
Build-Depends: debhelper-compat (=13)
Build-Depends-Arch: cmake (>=3.16.0),
                    libasound2-dev,
                    libavcodec-dev (>=7:3.2),
                    libavformat-dev (>=7:3.2),
                    libavutil-dev (>=7:3.2),
                    libdbusmenu-qt5-dev,
                    libexpected-dev,
                    libglib2.0-dev,
                    libglibmm-2.4-dev,
                    libgtk-3-dev,
                    libhunspell-dev,
                    libjemalloc-dev,
                    libkf5wayland-dev [linux-any],
                    liblz4-dev,
                    liblzma-dev,
                    libminizip-dev (>=1.1),
                    libmsgsl-dev (>=3.0.0),
                    libopenal-dev,
                    libopus-dev (>=1.1),
                    libpulse-dev,
                    libqrcodegencpp-dev,
                    libqt5svg5-dev,
                    libqt5waylandclient5-dev [linux-any],
                    librange-v3-dev (>=0.10.0),
                    librlottie-dev,
                    libssl-dev (>=1.0.1),
                    libswresample-dev (>=7:3.2),
                    libswscale-dev (>=7:3.2),
                    libtgowt-dev (>=0~git20211207),
                    libwebkit2gtk-4.0-dev,
                    libxcb-keysyms1-dev,
                    libxcb-record0-dev,
                    libxcb-screensaver0-dev,
                    libxcb1-dev,
                    libxxhash-dev,
                    python3:any,
                    qtbase5-dev (>=5.15.2),
                    qtbase5-private-dev (>=5.15.2),
                    qtwayland5-private-dev [linux-any],
                    zlib1g-dev (>=1:1.2.8)
Build-Conflicts-Arch: libtgvoip-dev
Standards-Version: 4.6.0
Rules-Requires-Root: no
Homepage: https://desktop.telegram.org
Vcs-Git: https://salsa.debian.org/debian/telegram-desktop.git
Vcs-Browser: https://salsa.debian.org/debian/telegram-desktop

Package: telegram-desktop
Architecture: amd64 arm64 armel armhf hurd-i386 i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips64el mipsel ppc64el riscv64 sh4 x32
Depends: qt5-image-formats-plugins, ${misc:Depends}, ${shlibs:Depends}, 
         fonts-open-sans
Built-Using: ${cpplibs:Built-Using}
Description: fast and secure messaging application
 Telegram is a messaging app with a focus on speed and security, it is
 super-fast, simple and free. You can use Telegram on all your devices at the
 same time — your messages sync seamlessly across any number of your phones,
 tablets or computers.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
include /usr/share/dpkg/default.mk

EXTRA_CMAKE_VARIABLES += \
	TDESKTOP_API_ID=50322 \
	TDESKTOP_API_HASH=9ff1a639196c0779c86dd661af8522ba \
	DESKTOP_APP_QT6=OFF \
	DESKTOP_APP_REQUIRE_JEMALLOC=OFF \
	DESKTOP_APP_USE_PACKED_RESOURCES=ON \
	CMAKE_STATIC_LINKER_FLAGS='-T'

DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Reveal any errors with pre-compiled headers.
DEB_CPPFLAGS_MAINT_APPEND += -Werror=invalid-pch

# Print full stack trace of template instantiations.
DEB_CXXFLAGS_MAINT_APPEND += -ftemplate-backtrace-limit=0

# Build scripts do not require compiled object code. This also shrinks result
# binary by 50 kB.
DEB_CXXFLAGS_MAINT_STRIP += -ffat-lto-objects

ifeq ($(filter terse,$(DEB_BUILD_OPTIONS)),)
 # Print entire arguments of moc invocation.
 EXTRA_CMAKE_VARIABLES += CMAKE_AUTOGEN_VERBOSE=ON
endif

ifneq ($(DEB_HOST_ARCH_OS),linux)
 # Wayland is not ready on GNU/Hurd or Debian/kFreeBSD.
 # Make sure KWayland library and Qt WaylandClient plugin are not in use.
 EXTRA_CMAKE_VARIABLES += DESKTOP_APP_DISABLE_WAYLAND_INTEGRATION=ON
 DEB_CPPFLAGS_MAINT_APPEND += -UQT_WAYLANDCLIENT_LIB
endif

ifeq ($(filter pkg.$(DEB_SOURCE).lotmem,$(DEB_BUILD_PROFILES)),)
 ifeq ($(DEB_BUILD_ARCH_BITS),32)
  ATTEMPT_SAVE_MEMORY = 1
 endif
 ifneq ($(filter Debian-riscv64 Ubuntu-arm64 Ubuntu-ppc64el,$(DEB_VENDOR)-$(DEB_BUILD_ARCH)),)
  ATTEMPT_SAVE_MEMORY = 1
 endif
 ifneq ($(filter -flto -flto=%,$(CXXFLAGS)),)
  ATTEMPT_SAVE_MEMORY = 1
 endif
 ifeq ($(DEB_BUILD_ARCH),mipsel)
  ifeq ($(filter nostrip,$(DEB_BUILD_OPTIONS)),)
   SPLIT_DEBUG_INFO = 1
  endif
 endif
endif
ifdef ATTEMPT_SAVE_MEMORY
 # Less debug info by default to fit small address space.
 ifneq ($(filter -g,$(CXXFLAGS)),)
  DEB_CXXFLAGS_MAINT_STRIP += -g
  DEB_CXXFLAGS_MAINT_PREPEND += -g1
 endif
 # Attempt to reduce RAM consumption even more.
 DEB_LDFLAGS_MAINT_APPEND += -Wl,--no-keep-memory
endif
ifdef SPLIT_DEBUG_INFO
 DEB_CXXFLAGS_MAINT_PREPEND += -gsplit-dwarf
endif

CPPLIBS_PACKAGES = libexpected-dev libmsgsl-dev librange-v3-dev libtgowt-dev
EXTRA_SUBSTVARS += \
	cpplibs:Built-Using=$(shell dpkg-query -Wf '$${source:Package}(=$${Version}),' $(CPPLIBS_PACKAGES))

# Make visible all possible maintainer's flags.
export DEB_BUILD_MAINT_OPTIONS $(foreach flag,$(DPKG_BUILDFLAGS_LIST),\
	$(foreach operation,STRIP APPEND PREPEND,DEB_$(flag)_MAINT_$(operation)))

# Make debugging a little easier. https://stackoverflow.com/a/25817631/5000805
# Print also export line if the variable is being exported.
print-%:
	@echo $* = $($*)
	@env | sed '/^\($*\)=.*/s//export \1/;t;d'

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(EXTRA_CMAKE_VARIABLES:%=-D%)
# Clear a redundant linker flag imposed by abseil. See https://bugs.debian.org/1001596
	sed -i 's/-Wl,--no-as-needed\>//g' obj-*/Telegram/CMakeFiles/Telegram.dir/link.txt

# Unset limit of debug information entries.
override_dh_dwz:
ifndef SPLIT_DEBUG_INFO
	dh_dwz -- -L none
else

# dwz(1) can't work with split DWARF, see: https://sourceware.org/bugzilla/show_bug.cgi?id=24756
# Gather debug references on my own before Debhelper moves it to -dbgsym package.
TELEGRAM_BINARY = debian/telegram-desktop/usr/bin/telegram-desktop
DBGSYM = debian/.debhelper/telegram-desktop/dbgsym-root
DBGDIR = usr/lib/debug/telegram-desktop
TRACING = $(if $(filter terse,$(DEB_BUILD_OPTIONS)),,-x)
execute_before_dh_strip:
	mkdir -p debian/tmp $(DBGSYM)/$(DBGDIR)
	TMPDIR=debian/tmp debian/dbgpatch.py $(TRACING) $(TELEGRAM_BINARY) $(DBGSYM) $(DBGDIR)
endif

override_dh_gencontrol:
	dh_gencontrol -- $(EXTRA_SUBSTVARS:%="-V%")

# MX don't need no stinkin' dbgsyms
override_dh_strip:
	dh_strip --no-automatic-dbgsym
